<?php
namespace Teknisa\EST\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Doctrine\ORM\EntityManager;
use \Zeedhi\Framework\DB\StoredProcedure\Param;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use PDO;


class ExportaSIMPController extends \Teknisa\EST\Controllers\TeknisaCrud
{
    public function __construct($dataSourceManager, $enviroment, $entityManager)
    {
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $enviroment;
        $this->entityManager = $entityManager;
    }

    function exportarSIMP(DTO\Request $request, DTO\Response $response){
        /*
        0000000000'||'Agente Regulado Informante'|| 'mes de referência'||'ano de referência'||total de linhas
        0000000000123456789008230000100
        */
        //formatação do conteúdo do arquivo txt
        $row = $request->getRow();
        
        $cdfilial   = $row['CDFILIAL'];
        $referencia = $row['REFERENCIA'];
        $empresa    = $row['CDEMPRESA'];
        $agente     = $row['AGENTE'];
        
        $data = explode("/", $referencia);                 
        $data_formatada = $data[1].$data[2];
        $nomeArquivo = 'SIMP.txt';
        
        $queryConteudo = $this->qrySIMP($cdfilial, $data_formatada, $referencia, $agente);
        
        $conteudo = '0000000000'.$agente.$data_formatada.count($queryConteudo);
        $caminhoCompleto = '/tmp/';
        $caminhoArquivo = $caminhoCompleto.$nomeArquivo;
        $fp = fopen($caminhoArquivo, 'w');
        if ($fp) {
            fwrite($fp, $conteudo.PHP_EOL);
            foreach($queryConteudo as $row){
                fwrite($fp, $row['DSDADOS'].PHP_EOL);
            }
            fclose($fp);
            $conteudoArquivo = file_get_contents($caminhoArquivo);
            $conteudoArquivo64 = base64_encode($conteudoArquivo);
            $response->addMessage(new DTO\Response\Message($conteudoArquivo64));
        } else {
            throw new \Exception("Falha ao abrir o arquivo para escrita");
        }
    }
           
    function qrySIMP($cdfilial, $dtini, $dtfin, $agente){
        $sql = "-- Estoque inicial proprio 
           SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '3010003'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(A.QTESTOQDIA))), 15, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(A.QTESTOQDIA))), 15, '0')||
           '0'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',8,'0')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, POSESTDIA A,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND A.CDFILIAL     = :P_CDFILIAL
        AND A.CDPRODUTO    = P.CDPRODUTO
        AND A.CDALMOXARIFE NOT IN (SELECT DISTINCT CDALMOXARIFE
                                    FROM AGENTETERCECLI
                                   WHERE CDFILIAL = :P_CDFILIAL
                                     AND NOT CDALMOXARIFE IS NULL
                                   UNION ALL
                                   SELECT DISTINCT CDALMOXINFOCLI
                                     FROM AGENTETERCECLI
                                    WHERE CDFILIAL = :P_CDFILIAL
                                      AND NOT CDALMOXINFOCLI IS NULL
                                    UNION ALL
                                   SELECT DISTINCT CDALMOXARIFE
                                     FROM AGENTETERCEFOR
                                    WHERE CDFILIAL = :P_CDFILIAL
                                      AND NOT CDALMOXARIFE IS NULL
                                    UNION ALL
                                    SELECT DISTINCT CDALMOXINFOFOR
                                      FROM AGENTETERCEFOR
                                     WHERE CDFILIAL = :P_CDFILIAL
                                       AND NOT CDALMOXINFOFOR IS NULL)
        AND A.QTESTOQDIA   >= 0
        AND A.DTPOSIESTQ   = DTPOSICAO_POSESTDIA(A.CDFILIAL, A.CDPRODUTO, A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ, A.NRSUBLOTE, TO_DATE('01'||:P_DTINI, 'DDMMYYYY'))
        GROUP BY '3010003',
              E.CDEMPINTEGRACAO,
              P.NRREGISTROANP
        UNION ALL
        -- Estoque inicial em terceiros
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '3010001'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(M.CODINST,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(A.QTESTOQDIA))), 15, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(A.QTESTOQDIA))), 15, '0')||
           '0'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',8,'0')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, POSESTDIA A,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) P,
           (SELECT DISTINCT C.CDCLIEEXPORT AS CODINST, A.CDALMOXINFOCLI AS CDLAMOX, A.CDLOCALINFOCLI AS CDLOCAL
              FROM AGENTETERCECLI A, EXPORTCLIE C
             WHERE CDFILIAL = :P_CDFILIAL
               AND NOT CDALMOXINFOCLI IS NULL
               AND C.CDCLIENTE = A.CDCLIENTE
             UNION ALL
             SELECT DISTINCT F.CDEXFORNECED AS CODINST, A.CDALMOXINFOFOR AS CDALMOX, A.CDLOCALINFOFOR AS CDLOCAL
               FROM AGENTETERCEFOR A, FORNECEDOR F
              WHERE CDFILIAL = :P_CDFILIAL
                AND NOT CDALMOXINFOFOR IS NULL
                AND F.CDFORNECED = A.CDFORNECED) M
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND A.CDFILIAL     = :P_CDFILIAL
        AND A.CDPRODUTO    = P.CDPRODUTO
        AND A.CDALMOXARIFE = M.CDLAMOX
        AND A.CDLOCALESTOQ = M.CDLOCAL
        AND A.QTESTOQDIA   >= 0
        AND A.DTPOSIESTQ   = DTPOSICAO_POSESTDIA(A.CDFILIAL, A.CDPRODUTO, A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ, A.NRSUBLOTE, TO_DATE('01'||:P_DTINI, 'DDMMYYYY'))
        GROUP BY :P_AGENTE,
              TO_DATE('01'||:P_DTINI, 'DDMMYYYY'),
              '3010001',
              E.CDEMPINTEGRACAO,
              M.CODINST,
              P.NRREGISTROANP
        UNION ALL
        -- Estoque inicial de terceiros
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '3010002'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(M.CODINST,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(A.QTESTOQDIA))), 15, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(A.QTESTOQDIA))), 15, '0')||
           '0'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',8,'0')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, POSESTDIA A,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) P,
           (SELECT DISTINCT C.CDCLIEEXPORT AS CODINST, A.CDALMOXARIFE AS CDLAMOX, A.CDLOCALESTOQ AS CDLOCAL
              FROM AGENTETERCECLI A, EXPORTCLIE C
             WHERE CDFILIAL = :P_CDFILIAL
               AND NOT CDALMOXARIFE IS NULL
               AND C.CDCLIENTE = A.CDCLIENTE
             UNION ALL
             SELECT DISTINCT F.CDEXFORNECED AS CODINST, A.CDALMOXARIFE AS CDALMOX, A.CDLOCALESTOQ AS CDLOCAL
               FROM AGENTETERCEFOR A, FORNECEDOR F
              WHERE CDFILIAL = :P_CDFILIAL
                AND NOT CDALMOXARIFE IS NULL
                AND F.CDFORNECED = A.CDFORNECED) M
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND A.CDFILIAL     = :P_CDFILIAL
        AND A.CDPRODUTO    = P.CDPRODUTO
        AND A.CDALMOXARIFE = M.CDLAMOX
        AND A.CDLOCALESTOQ = M.CDLOCAL
        AND A.QTESTOQDIA   >= 0
        AND A.DTPOSIESTQ   = DTPOSICAO_POSESTDIA(A.CDFILIAL, A.CDPRODUTO, A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ, A.NRSUBLOTE, TO_DATE('01'||:P_DTINI, 'DDMMYYYY'))
        GROUP BY :P_AGENTE,
              TO_DATE('01'||:P_DTINI, 'DDMMYYYY'),
              '3010002',
              E.CDEMPINTEGRACAO,
              M.CODINST,
              P.NRREGISTROANP
        UNION ALL
        -- Compra agente regulado
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '1011001'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(R.CDEXFORNECED,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '1'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           TO_CHAR(N.DTEMISSAO, 'DDMMYYYY')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD(N.NRACESSONFE,44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N, FORNECEDOR R,
           ITEMPRODUTO I, TIPOOPERAC T,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND ((NOT I.NRREGISTROANP IS NULL) AND (I.NRREGISTROANP <> '620601004'))) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIRECE   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'E'
        AND NVL(N.IDORIGDESTNF,'F') = 'F'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND R.CDFORNECED   = N.CDFORNECED
        AND NOT R.CDEXFORNECED IS NULL
        AND T.IDENTRSAIDOP = N.IDENTRSAIDOP
        AND T.CDTIPOOPER   = N.CDTIPOOPER
        AND NVL(T.IDNFIMPORTACAO, 'N') = 'N'
        UNION ALL
        -- Compra agente nao regulado
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '1011002'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '1'||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(N.NRINSJURNF,'0'), 1, 14), 14, '0')||
           LPAD(SUBSTR(NVL(M.CDMUNIEXPO,'0'), 1, 7), 7, '0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           TO_CHAR(N.DTEMISSAO, 'DDMMYYYY')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD(N.NRACESSONFE,44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N, FORNECEDOR R,
           ITEMPRODUTO I, TIPOOPERAC T, MUNICIPIO M, ENDEFORN D,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND ((NOT I.NRREGISTROANP IS NULL) AND (I.NRREGISTROANP <> '620601004'))) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIRECE   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'E'
        AND NVL(N.IDORIGDESTNF,'F') = 'F'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND R.CDFORNECED   = N.CDFORNECED
        AND R.CDEXFORNECED IS NULL
        AND T.IDENTRSAIDOP = N.IDENTRSAIDOP
        AND T.CDTIPOOPER   = N.CDTIPOOPER
        AND NVL(T.IDNFIMPORTACAO, 'N') = 'N'
        AND D.CDFORNECED   = N.CDFORNECED
        AND D.IDTPENDEFORN = 'P'
        AND M.CDPAIS       = D.CDPAIS
        AND M.SGESTADO     = D.SGESTADO
        AND M.CDMUNICIPIO  = D.CDMUNICIPIO
        UNION ALL
        -- Devolucao venda agente regulado
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '1011004'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(R.CDCLIEEXPORT,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '1'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           TO_CHAR(N.DTEMISSAO, 'DDMMYYYY')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD(N.NRACESSONFE,44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N, EXPORTCLIE R,
           ITEMPRODUTO I, TIPOOPERAC T,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND ((NOT I.NRREGISTROANP IS NULL) AND (I.NRREGISTROANP <> '620601004'))) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIRECE   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'E'
        AND NVL(N.IDORIGDESTNF,'F') = 'C'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND R.CDCLIENTE    = N.CDCLIENTE
        AND NOT R.CDCLIEEXPORT IS NULL
        AND T.IDENTRSAIDOP = N.IDENTRSAIDOP
        AND T.CDTIPOOPER   = N.CDTIPOOPER
        AND NVL(T.IDNFIMPORTACAO, 'N') = 'N'
        UNION ALL
        -- Devolucao venda agente nao regulado
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '1011005'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '1'||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(N.NRINSJURNF,'0'), 1, 14), 14, '0')||
           LPAD(SUBSTR(NVL(M.CDMUNIEXPO,'0'), 1, 7), 7, '0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           TO_CHAR(N.DTEMISSAO, 'DDMMYYYY')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD(N.NRACESSONFE,44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N, EXPORTCLIE R,
           ITEMPRODUTO I, TIPOOPERAC T, MUNICIPIO M, ENDECLIE D,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND ((NOT I.NRREGISTROANP IS NULL) AND (I.NRREGISTROANP <> '620601004'))) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIRECE   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'E'
        AND NVL(N.IDORIGDESTNF,'F') = 'C'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND R.CDCLIENTE (+) = N.CDCLIENTE
        AND R.CDCLIEEXPORT IS NULL
        AND T.IDENTRSAIDOP = N.IDENTRSAIDOP
        AND T.CDTIPOOPER   = N.CDTIPOOPER
        AND NVL(T.IDNFIMPORTACAO, 'N') = 'N'
        AND D.CDCLIENTE    = N.CDCLIENTE
        AND D.IDTPENDECLIE = 'P'
        AND M.CDPAIS       = D.CDPAIS
        AND M.SGESTADO     = D.SGESTADO
        AND M.CDMUNICIPIO  = D.CDMUNICIPIO
        UNION ALL
        -- Producao por Mistura
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '1021004'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(I.QTTOTLANCTO))), 15, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(I.QTTOTLANCTO))), 15, '0')||
           '0'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',8,'0')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E,
           ITLANCTOEST I, PRODACABADO O,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND I.CDFILIMOVI   = :P_CDFILIAL
        AND I.DTLANCMOVI BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND I.IDTIPOMOVI   = '2'
        AND I.IDEVOLESTOQ  = 'S'
        AND O.CDFILIAL     = I.CDFILIAL
        AND O.NRLANCESTQ   = I.NRLANCESTQ
        AND O.NRSEQUITEM   = I.NRSEQUITEM
        AND P.CDPRODUTO    = I.CDPRODUTO
        GROUP BY :P_AGENTE,
              TO_DATE('01'||:P_DTINI, 'DDMMYYYY'),
              '1021004',
              E.CDEMPINTEGRACAO,
              P.NRREGISTROANP
        UNION ALL
        -- Transferencia de produtos (Entrada)
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '1051001'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(R.CDEXFILIAL,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '1'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           TO_CHAR(N.DTEMISSAO, 'DDMMYYYY')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD(N.NRACESSONFE,44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N, PARAMFILIAL R, ITEMPRODUTO I,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIRECE   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'E'
        AND NVL(N.IDORIGDESTNF,'F') = 'L'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND R.CDFILIAL   = N.CDFILIEMIT
        AND NOT R.CDEXFILIAL IS NULL
        UNION ALL
        -- Venda agente regulado
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '1012001'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(R.CDCLIEEXPORT,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '1'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           TO_CHAR(N.DTEMISSAO, 'DDMMYYYY')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD(N.NRACESSONFE,44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N, EXPORTCLIE R, ITEMPRODUTO I,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND ((NOT I.NRREGISTROANP IS NULL) AND (I.NRREGISTROANP <> '620601004'))) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIEMIT   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'S'
        AND NVL(N.IDORIGDESTNF,'F') = 'C'
        AND N.IDSTATUSNFE = 'A'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND N.CDMODDOCFISC = '55'
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND R.CDCLIENTE   = N.CDCLIENTE
        AND NOT R.CDCLIEEXPORT IS NULL
        UNION ALL
        -- Venda agente nao regulado
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '1012002'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '1'||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(N.NRINSJURNF,'0'), 1, 14), 14, '0')||
           LPAD(SUBSTR(NVL(M.CDMUNIEXPO,'0'), 1, 7), 7, '0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           TO_CHAR(N.DTEMISSAO, 'DDMMYYYY')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD(N.NRACESSONFE,44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N, EXPORTCLIE R, ITEMPRODUTO I,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND ((NOT I.NRREGISTROANP IS NULL) AND (I.NRREGISTROANP <> '620601004'))) P,
           MUNICIPIO M, ENDECLIE D
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIEMIT   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'S'
        AND NVL(N.IDORIGDESTNF,'F') = 'C'
        AND N.IDSTATUSNFE = 'A'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND N.CDMODDOCFISC = '55'
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND R.CDCLIENTE (+) = N.CDCLIENTE
        AND R.CDCLIEEXPORT IS NULL
        AND D.CDCLIENTE    = N.CDCLIENTE
        AND D.IDTPENDECLIE = 'P'
        AND M.CDPAIS       = D.CDPAIS
        AND M.SGESTADO     = D.SGESTADO
        AND M.CDMUNICIPIO  = D.CDMUNICIPIO
        UNION ALL
        -- Venda de lubrificantes no varejo
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '1012017'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '0'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD(SUBSTR(NVL(M.CDMUNIEXPO,'0'), 1, 7), 7, '0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',8,'0')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N,
           ITEMPRODUTO I, MUNICIPIO M, ENDECLIE D,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIEMIT   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'S'
        AND NVL(N.IDORIGDESTNF,'F') = 'C'
        AND N.IDSTATUSNFE = 'A'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND N.CDMODDOCFISC = '65'
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND D.CDCLIENTE    = N.CDCLIENTE
        AND D.IDTPENDECLIE = 'P'
        AND M.CDPAIS       = D.CDPAIS
        AND M.SGESTADO     = D.SGESTADO
        AND M.CDMUNICIPIO  = D.CDMUNICIPIO
        UNION ALL
        -- Devolucao compra agente regulado
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '1012004'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(R.CDEXFORNECED,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '1'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           TO_CHAR(N.DTEMISSAO, 'DDMMYYYY')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD(N.NRACESSONFE,44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N, FORNECEDOR R, ITEMPRODUTO I,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND ((NOT I.NRREGISTROANP IS NULL) AND (I.NRREGISTROANP <> '620601004'))) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIEMIT   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'S'
        AND NVL(N.IDORIGDESTNF,'F') = 'F'
        AND N.CDTIPOOPER = '06'
        AND N.IDSTATUSNFE = 'A'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND R.CDFORNECED   = N.CDFORNECED
        AND NOT R.CDEXFORNECED IS NULL
        UNION ALL
        -- Devolucao venda agente nao regulado
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '1012005'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '1'||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(N.NRINSJURNF,'0'), 1, 14), 14, '0')||
           LPAD(SUBSTR(NVL(M.CDMUNIEXPO,'0'), 1, 7), 7, '0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           TO_CHAR(N.DTEMISSAO, 'DDMMYYYY')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD(N.NRACESSONFE,44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N, FORNECEDOR R,
           ITEMPRODUTO I, MUNICIPIO M, ENDEFORN D,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND ((NOT I.NRREGISTROANP IS NULL) AND (I.NRREGISTROANP <> '620601004'))) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIEMIT   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'S'
        AND NVL(N.IDORIGDESTNF,'F') = 'F'
        AND N.CDTIPOOPER = '06'
        AND N.IDSTATUSNFE = 'A'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND R.CDFORNECED = N.CDFORNECED
        AND R.CDEXFORNECED IS NULL
        AND D.CDFORNECED   = N.CDFORNECED
        AND D.IDTPENDEFORN = 'P'
        AND M.CDPAIS       = D.CDPAIS
        AND M.SGESTADO     = D.SGESTADO
        AND M.CDMUNICIPIO  = D.CDMUNICIPIO
        UNION ALL
        -- Mistura de Produtos
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '1022015'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(I.QTTOTLANCTO))), 15, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(I.QTTOTLANCTO))), 15, '0')||
           '1'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',8,'0')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD(SUBSTR(NVL(A.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E,
           ITLANCTOEST I, RETIRADAESTO R, ORDPRODUCAO O,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) P,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) A
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND I.CDFILIMOVI   = :P_CDFILIAL
        AND I.DTLANCMOVI BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND I.IDTIPOMOVI   = '3'
        AND I.IDEVOLESTOQ  = 'S'
        AND R.CDFILIAL     = I.CDFILIAL
        AND R.NRLANCESTQ   = I.NRLANCESTQ
        AND O.CDFILIAL      = R.CDFILIAL
        AND O.NRORDPROD     = R.NRORDPROD
        AND O.NRSUBORDPROD  = R.NRSUBORDPROD
        AND P.CDPRODUTO     = I.CDPRODUTO
        AND A.CDPRODUTO     = O.CDPRODUTO
        GROUP BY :P_AGENTE,
              TO_DATE('01'||:P_DTINI, 'DDMMYYYY'),
              '1022015',
              E.CDEMPINTEGRACAO,
              P.NRREGISTROANP,
              A.NRREGISTROANP
        UNION ALL
        -- Transferencia de produtos (Saidas)
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '1052001'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(R.CDEXFILIAL,'0'), 1, 7), 7, ' ')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '1'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           TO_CHAR(N.DTEMISSAO, 'DDMMYYYY')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD(N.NRACESSONFE,44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N, PARAMFILIAL R, ITEMPRODUTO I,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIEMIT   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'S'
        AND NVL(N.IDORIGDESTNF,'F') = 'L'
        AND N.IDSTATUSNFE = 'A'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND R.CDFILIAL   = N.CDFILIRECE
        AND NOT R.CDEXFILIAL IS NULL
        UNION ALL
        -- Importação de Produtos
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '2011001'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '1'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD(SUBSTR(NVL(S.CDPAISEXPFIS,'0'), 1, 4), 4, '0')||
           LPAD('0',10,'0')||
           LPAD(SUBSTR(NVL(M.NRDOCIMPNFE,'0'), 1, 10), 10, '0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           TO_CHAR(N.DTEMISSAO, 'DDMMYYYY')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD(N.NRACESSONFE,44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N, ITEMPRODUTO I,
           TIPOOPERAC T, DECIMPNFE M, PAIS S, ENDEFORN D,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIRECE   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'E'
        AND NVL(N.IDORIGDESTNF,'F') = 'F'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND T.IDENTRSAIDOP = N.IDENTRSAIDOP
        AND T.CDTIPOOPER   = N.CDTIPOOPER
        AND T.IDNFIMPORTACAO = 'S'
        AND M.CDFILIAL     = I.CDFILIAL
        AND M.NRLANCTONF   = I.NRLANCTONF
        AND M.NRSEQITPROD  = I.NRSEQITPROD
        AND D.CDFORNECED   = N.CDFORNECED
        AND D.IDTPENDEFORN = 'P'
        AND S.CDPAIS       = D.CDPAIS
        UNION ALL
        -- Exportacao de Produtos
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '2012001'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '1'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD(SUBSTR(NVL(S.CDPAISEXPFIS,'0'), 1, 4), 4, '0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           TO_CHAR(N.DTEMISSAO, 'DDMMYYYY')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD(N.NRACESSONFE,44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N, EXPORTCLIE R,
           ITEMPRODUTO I, PAIS S, ENDECLIE D,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIEMIT   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'S'
        AND NVL(N.IDORIGDESTNF,'F') = 'C'
        AND N.IDSTATUSNFE = 'A'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND N.CDMODDOCFISC = '55'
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND R.CDCLIENTE   = N.CDCLIENTE
        AND NOT R.CDCLIEEXPORT IS NULL
        AND D.CDCLIENTE   = N.CDCLIENTE
        AND D.IDTPENDECLIE = 'P'
        AND S.CDPAIS       = D.CDPAIS
        AND S.CDPAIS <> '0055'
        UNION ALL
        -- Devolucao exportacao de Produtos
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '2012003'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '0'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD(SUBSTR(NVL(S.CDPAISEXPFIS,'0'), 1, 4), 4, '0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           TO_CHAR(N.DTEMISSAO, 'DDMMYYYY')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD(N.NRACESSONFE,44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N, FORNECEDOR R,
           ITEMPRODUTO I, PAIS S, ENDEFORN D,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIEMIT   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'S'
        AND NVL(N.IDORIGDESTNF,'F') = 'F'
        AND N.CDTIPOOPER = '06'
        AND N.IDSTATUSNFE = 'A'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND R.CDFORNECED   = N.CDFORNECED
        AND NOT R.CDEXFORNECED IS NULL
        AND D.CDFORNECED   = N.CDFORNECED
        AND D.IDTPENDEFORN = 'P'
        AND S.CDPAIS       = D.CDPAIS
        AND S.CDPAIS <> '0055'
        UNION ALL
        -- Estoque final proprio
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '3020003'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(A.QTESTOQDIA))), 15, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(A.QTESTOQDIA))), 15, '0')||
           '0'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',8,'0')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, POSESTDIA A,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND A.CDFILIAL     = :P_CDFILIAL
        AND A.CDPRODUTO    = P.CDPRODUTO
        AND A.CDALMOXARIFE NOT IN (SELECT DISTINCT CDALMOXARIFE
                                    FROM AGENTETERCECLI
                                   WHERE CDFILIAL = :P_CDFILIAL
                                     AND NOT CDALMOXARIFE IS NULL
                                   UNION ALL
                                   SELECT DISTINCT CDALMOXINFOCLI
                                     FROM AGENTETERCECLI
                                    WHERE CDFILIAL = :P_CDFILIAL
                                      AND NOT CDALMOXINFOCLI IS NULL
                                    UNION ALL
                                   SELECT DISTINCT CDALMOXARIFE
                                     FROM AGENTETERCEFOR
                                    WHERE CDFILIAL = :P_CDFILIAL
                                      AND NOT CDALMOXARIFE IS NULL
                                    UNION ALL
                                    SELECT DISTINCT CDALMOXINFOFOR
                                      FROM AGENTETERCEFOR
                                     WHERE CDFILIAL = :P_CDFILIAL
                                       AND NOT CDALMOXINFOFOR IS NULL)
        AND A.QTESTOQDIA   >= 0
        AND A.DTPOSIESTQ   = DTPOSICAO_POSESTDIA(A.CDFILIAL, A.CDPRODUTO, A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ, A.NRSUBLOTE, TO_DATE('01'||:P_DTINI, 'DDMMYYYY')+ 1)
        GROUP BY :P_AGENTE,
              TO_DATE('01'||:P_DTINI, 'DDMMYYYY'),
              '3020003',
              E.CDEMPINTEGRACAO,
              P.NRREGISTROANP
        UNION ALL
        -- Estoque final em terceiros
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
            '3020001'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(M.CODINST,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(A.QTESTOQDIA))), 15, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(A.QTESTOQDIA))), 15, '0')||
           '0'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',8,'0')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, POSESTDIA A,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) P,
           (SELECT DISTINCT C.CDCLIEEXPORT AS CODINST, A.CDALMOXINFOCLI AS CDLAMOX, A.CDLOCALINFOCLI AS CDLOCAL
              FROM AGENTETERCECLI A, EXPORTCLIE C
             WHERE CDFILIAL = :P_CDFILIAL
               AND NOT CDALMOXINFOCLI IS NULL
               AND C.CDCLIENTE = A.CDCLIENTE
             UNION ALL
             SELECT DISTINCT F.CDEXFORNECED AS CODINST, A.CDALMOXINFOFOR AS CDALMOX, A.CDLOCALINFOFOR AS CDLOCAL
               FROM AGENTETERCEFOR A, FORNECEDOR F
              WHERE CDFILIAL = :P_CDFILIAL
                AND NOT CDALMOXINFOFOR IS NULL
                AND F.CDFORNECED = A.CDFORNECED) M
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND A.CDFILIAL     = :P_CDFILIAL
        AND A.CDPRODUTO    = P.CDPRODUTO
        AND A.CDALMOXARIFE = M.CDLAMOX
        AND A.CDLOCALESTOQ = M.CDLOCAL
        AND A.QTESTOQDIA   >= 0
        AND A.DTPOSIESTQ   = DTPOSICAO_POSESTDIA(A.CDFILIAL, A.CDPRODUTO, A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ, A.NRSUBLOTE, TO_DATE(:P_DTFIN, 'DD/MM/YYYY') +1)
        GROUP BY :P_AGENTE,
              TO_DATE('01'||:P_DTINI, 'DDMMYYYY'),
              '3020001',
              E.CDEMPINTEGRACAO,
              M.CODINST,
              P.NRREGISTROANP
        UNION ALL
        -- Estoque final de terceiros
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '3020002'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(M.CODINST,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(A.QTESTOQDIA))), 15, '0')||
           LPAD(TO_CHAR(TRUNC(SUM(A.QTESTOQDIA))), 15, '0')||
           '0'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD('0',7,'0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',8,'0')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, POSESTDIA A,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND NOT I.NRREGISTROANP IS NULL) P,
           (SELECT DISTINCT C.CDCLIEEXPORT AS CODINST, A.CDALMOXARIFE AS CDLAMOX, A.CDLOCALESTOQ AS CDLOCAL
              FROM AGENTETERCECLI A, EXPORTCLIE C
             WHERE CDFILIAL = :P_CDFILIAL
               AND NOT CDALMOXARIFE IS NULL
               AND C.CDCLIENTE = A.CDCLIENTE
             UNION ALL
             SELECT DISTINCT F.CDEXFORNECED AS CODINST, A.CDALMOXARIFE AS CDALMOX, A.CDLOCALESTOQ AS CDLOCAL
               FROM AGENTETERCEFOR A, FORNECEDOR F
              WHERE CDFILIAL = :P_CDFILIAL
                AND NOT CDALMOXARIFE IS NULL
                AND F.CDFORNECED = A.CDFORNECED) M
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND A.CDFILIAL     = :P_CDFILIAL
        AND A.CDPRODUTO    = P.CDPRODUTO
        AND A.CDALMOXARIFE = M.CDLAMOX
        AND A.CDLOCALESTOQ = M.CDLOCAL
        AND A.QTESTOQDIA   >= 0
        AND A.DTPOSIESTQ   = DTPOSICAO_POSESTDIA(A.CDFILIAL, A.CDPRODUTO, A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ, A.NRSUBLOTE, TO_DATE(:P_DTFIN, 'DD/MM/YYYY') +1)
        GROUP BY :P_AGENTE,
              TO_DATE('01'||:P_DTINI, 'DDMMYYYY'),
              '3020002',
              E.CDEMPINTEGRACAO,
              M.CODINST,
              P.NRREGISTROANP
        UNION ALL
        -- Dispensado de coleta
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '4030001'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD('0',7,'0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '0'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD(SUBSTR(NVL(M.CDMUNIEXPO,'0'), 1, 7), 7, '0')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',8,'0')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N,
           ITEMPRODUTO I, MUNICIPIO M, ENDECLIE D,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND I.NRREGISTROANP = '620601004') P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIEMIT   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'S'
        AND NVL(N.IDORIGDESTNF,'F') = 'C'
        AND N.IDSTATUSNFE = 'A'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND N.CDMODDOCFISC = '55'
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND D.CDCLIENTE    = N.CDCLIENTE
        AND D.IDTPENDECLIE = 'P'
        AND M.CDPAIS       = D.CDPAIS
        AND M.SGESTADO     = D.SGESTADO
        AND M.CDMUNICIPIO  = D.CDMUNICIPIO
        UNION ALL
        -- Recebimento de devolução de dispensado de Coleta
        SELECT LPAD(:P_AGENTE, 10 , '0')||
           TO_CHAR(TO_DATE('01'||:P_DTINI, 'DDMMYYYY'), 'MMYYYY')||
           '4030003'||
           LPAD(SUBSTR(NVL(E.CDEMPINTEGRACAO,'0'), 1, 7), 7, '0')||
           LPAD(SUBSTR(NVL(P.NRREGISTROANP,'0'), 1, 9), 9, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           LPAD(TO_CHAR(TRUNC(I.QTITEMPROD)), 15, '0')||
           '0'||
           LPAD('0',7,'0')||
           LPAD('0',14,'0')||
           LPAD(SUBSTR(NVL(M.CDMUNIEXPO,' '), 1, 7), 7, ' ')||
           '99999'||
           LPAD('0',4,'0')||
           LPAD('0',10,'0')||
           LPAD('0',10,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',8,'0')||
           LPAD('0',1,'0')||
           LPAD('0',3,'0')||
           LPAD('0',3,'0')||
           LPAD('0',2,'0')||
           LPAD('0',10,'0')||
           LPAD('0',9,'0')||
           LPAD('0',7,'0')||
           LPAD('0',2,'0')||
           LPAD('0',44,'0') AS DSDADOS
        FROM FILIAL F, PARAMEMPRESA E, NOTAFISCAL N,
           ITEMPRODUTO I, MUNICIPIO M, ENDECLIE D,
           (SELECT P.CDPRODUTO, I.NRREGISTROANP
              FROM PRODUTO P, INFADICPROD I
             WHERE I.CDPRODUTO = P.CDPRODUTO
               AND I.NRREGISTROANP = '620601004') P
        WHERE F.CDFILIAL     = :P_CDFILIAL
        AND E.CDEMPRESA    = F.CDEMPRESA
        AND N.CDFILIEMIT   = :P_CDFILIAL
        AND N.IDENTRSAIDOP = 'E'
        AND NVL(N.IDORIGDESTNF,'F') = 'C'
        AND N.DTENTRSAID BETWEEN TO_DATE('01'||:P_DTINI, 'DDMMYYYY') AND TO_DATE(:P_DTFIN)
        AND N.CDMODDOCFISC = '55'
        AND I.CDFILIAL     = N.CDFILIAL
        AND I.NRLANCTONF   = N.NRLANCTONF
        AND P.CDPRODUTO    = I.CDPRODUTO
        AND D.CDCLIENTE    = N.CDCLIENTE
        AND D.IDTPENDECLIE = 'P'
        AND M.CDPAIS       = D.CDPAIS
        AND M.SGESTADO     = D.SGESTADO
        AND M.CDMUNICIPIO  = D.CDMUNICIPIO";

        $parametros = array(
            "P_CDFILIAL" => $cdfilial,
            "P_DTINI"    => $dtini,
            "P_DTFIN"    => $dtfin,
            "P_AGENTE"   => $agente
        );
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($parametros); 
        return $std->fetchAll();
    }
}
