<?php
namespace Teknisa\EST\Modules\EstoqueCego\Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;
use \Zeedhi\Framework\DB\StoredProcedure\Param;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Est96000DivergenciasInventarioCegoService {
    
    protected $factory;
    protected $environment;
    protected $dataSourceManager;
    protected $entityManager;
    protected $connection;
    
    public function __construct($Est96000factory, $environment,$dataSourceManager,$entityManager) {
        $this->factory = $Est96000factory;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }
    
    public function getParperdivestceg($CDFILIAL,$CDPRODUTO) {
        $params = [
            "CDFILIAL" => $CDFILIAL,
            "CDPRODUTO" => $CDPRODUTO
        ];
        return $this->factory->getParperdivestceg($params);
    }
    
    public function getCardapioInfo($cdfilial,$dtreti,$cdservbaiestceg) {
        $params = [
            "CDFILIAL" => $cdfilial,
            "CDSERVFILI" => $cdservbaiestceg,
            "DTCARDAPIO" => $dtreti,
            "NRCARDAPIO" => 'T'
        ];
        return $this->factory->getCardapioInfo($params);
    }
    
    public function VerifyRetirada($cdfilial,$dtcontagem) {
        $params = [
            "CDFILIMOVI" => $cdfilial,
            "DTLANCESTQ" => $dtcontagem
        ];
        return $this->factory->VerifyRetirada($params);
    }
    
    public function VerifyRequisition($cdfilial,$dtcontagem,$idrequisao) {
        $params = [
            "CDFILIAL" => $cdfilial,
            "DTCONTAGEM" => $dtcontagem,
            "IDREQUISAO" => $idrequisao
        ];
        return $this->factory->VerifyRequisition($params);
    }
    
    public function VerifyEfetive($cdfilial,$dtcontagem,$idrequisao) {
        $params = [
            "CDFILIAL" => $cdfilial,
            "DTCONTAGEM" => $dtcontagem,
            "IDEFETIVO" => $idrequisao
        ];
        return $this->factory->VerifyRequisition($params);
    }
    
    public function executaProcedureGeraAjusteInvCego(
        $cdfilial, 
        $dtcontagem, 
        $cdfilimovi, 
        $cdalmoxarife, 
        $cdlocalestoq, 
        $nrlancestq, 
        $nrlancret, 
        $nrretirada, 
        $nrcardapio, 
        $operador, 
        $geraretirada
        ) {
        #creates procedure
        $procedure = new StoredProcedure($this->connection, 'GERA_AJUSTE_INVCEGO');
        
        #sets all parameters
        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $cdfilial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTCONTAGEM', Param::PARAM_INPUT, $dtcontagem, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDALMOXARIFE', Param::PARAM_INPUT, $cdalmoxarife, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDLOCALESTOQ', Param::PARAM_INPUT, $cdlocalestoq, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILILANC', Param::PARAM_INPUT, $cdfilimovi, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRLANCESTQ', Param::PARAM_INPUT, $nrlancestq, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRLANCRET', Param::PARAM_INPUT, $nrlancret, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRRETIRADA', Param::PARAM_INPUT, $nrretirada, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRCARDAPIO', Param::PARAM_INPUT, $nrcardapio, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $operador, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_GERARETI', Param::PARAM_INPUT, $geraretirada, Param::PARAM_TYPE_STR));
        
        #execute procedure
        $procedure->execute();
    }
    
    public function getItemsWithoutCost($cdfilimovi,$cdalmoxarife,$cdlocalestoq,$dtcontagem) {
        $params = [
            "CDFILIAL" => $cdfilimovi,
            "CDALMOXARIFE" => $cdalmoxarife,
            "CDLOCALESTOQ" => $cdlocalestoq,
            "DTCONTAGEM" => $dtcontagem
        ];
        return $this->factory->getItemsWithoutCost($params);
    }
    
}
