function est46000_EmissaoAjusteInventario_Controller(General, MessageService, ScreenService, restEngine, maskEngine, ZhUtil, templateManager, localStorageEngine, ZhReports, ProductField, Est46000_EmissaoAjusteInventario_Service, Est31300_MovimentacaodeEstoque_Service, ZhLayoutPreferences) {

    this.defaultValueEmissaoAjuste = function(args) {
        var formWidget = args.owner;
        args.row.REPORT_NAME = 'EST46000';
        args.row.DTPERINI = moment().startOf('month').format('DD/MM/YYYY');
        args.row.DTPERFIN = moment().endOf('month').format('DD/MM/YYYY');
        args.row.INTERVALO = {
            "start": args.row.DTPERINI,
            "end": args.row.DTPERFIN,
            "formattedStart": args.row.DTPERINI,
            "formattedEnd": args.row.DTPERFIN
        };
        args.row.CUSTOS = 1;
        args.row.NRORG = getLocalVar('ERP_NRORGTRAB') || getLocalVar('NRORGTRAB');
        args.row.ORDENA = 1;

        var campoNivel = formWidget.getField('NPTOTALIZA');

        let SetTime = setInterval((time) => {
            var levels = General.getLevelByMask('GER_CDPICTPROD', 1);
            campoNivel.dataSource.data = [];
            for (var index in levels) {
                if (index < levels.length)
                    campoNivel.dataSource.data.push({
                        "name": levels[index].nivel,
                        "value": levels[index].caracteres
                    });
            }

            // campoNivel.setValue(campoNivel.dataSource.data[0].value);

            this.getFilialLogada().then(success => {
                args.row.CDFILIAL = success.dataset.filial[0].CDFILIAL;
                args.row.NMFILIAL = success.dataset.filial[0].NMFILIAL;
                var widget = templateManager.container.getActiveWidget();
                let currentRow = widget.currentRow;

                widget.getField('DSALMOXARIFE').dataSourceFilter.forEach(function(fil) {
                    if (fil.name == "CDFILIAL") {
                        fil.value = currentRow.CDFILIAL;
                    }
                });
                widget.getField('DSLOCALESTOQ').dataSourceFilter.forEach(function(fil) {
                    if (fil.name == "CDFILIAL") {
                        fil.value = currentRow.CDFILIAL;
                    }
                });
                widget.getField('DSALMOXARIFE').reload();
                widget.getField('DSLOCALESTOQ').reload();
                this.checkUnidadeFields(widget);
            });
            clearInterval(SetTime);
        }, 2500);
    };

    this.getFilialLogada = function() {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };

    this.geraRelatorio = function(widget, type) { //receber em type xls ou pdf
        var REPORT_JSON = "./json/reports/est46001_relatorio.json";

        ScreenService.showLoader();
        restEngine.requestMetaData(REPORT_JSON).then(function(reportMetaData) {
            ScreenService.hideLoader();
            ZhReports.openReport(reportMetaData.data, widget, null, null, type);
        });
    };
    
    

    this.validaData = function(currentRow) {

        var dataInicial = currentRow.DTPERINI ? moment(currentRow.DTPERINI, 'DD/MM/YYYY')._d : null;
        var dataFinal = currentRow.DTPERFIN ? moment(currentRow.DTPERFIN, 'DD/MM/YYYY')._d : null;

        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            MessageService.showMessageByCode('DATA_RANGE');
            return false;
        }
        return true;
    };

    this.comparaPratoProduto = function(pinicial, pfinal, mascara) {
        var mask = {
            type: "fix",
            params: {
                mask: mascara
            }
        };
        pinicial = Util.applyMask(pinicial, mask, maskEngine, ZhUtil).split('.');
        pfinal = Util.applyMask(pfinal, mask, maskEngine, ZhUtil).split('.');
        var nvinicial = pinicial.length;
        var nvfinal = pfinal.length;
        var resultado = true;
        if (nvinicial != nvfinal) {
            if (nvinicial > nvfinal) {
                resultado = false;
            }
        }
        else {
            var i = 0;
            do {
                if (pinicial[i] > pfinal[i]) {
                    resultado = false;
                }
                i++;
            }
            while (i < pinicial.length && resultado);
        }
        return resultado;
    };

    this.validaNivel = function(currentRow) {
        var retorno = '';

        if (currentRow.CDARVPRODINI && currentRow.CDARVPRODFIN) {
            retorno = this.comparaPratoProduto(currentRow.CDARVPRODINI, currentRow.CDARVPRODFIN, getLocalVar('CDPICTPROD'));
            if (!retorno) {
                MessageService.showMessageByCode('PRODUTO_INICIAL_MAIOR_FINAL');
                return false;
            }
            return true;
        }
        return false;
    };

    this.validaRelatorioGrid = function(currentRow, widget) {
        if (widget.isValid() && this.validaData(currentRow) && this.validaNivel(currentRow)) {
            var rowStripe = {};
            rowStripe.DSFILIAL = currentRow.CDFILIAL + ' - ' + currentRow.NMFILIAL;
            rowStripe.DSPRODUTO = currentRow.CDARVPRODINI + ' à ' + currentRow.CDARVPRODFIN;
            rowStripe.DSPERIODO = currentRow.DTPERINI + ' à ' + currentRow.DTPERFIN;
            rowStripe.CUSTOS = currentRow.CUSTOS;
            localStorageEngine.setDataSource('/StripeEmissao', rowStripe);
            currentRow.CDPRODFIN = currentRow.CDARVPRODFIN + "zzzzzzzzzzzzzzzzzzzz";
            currentRow.CDPRODFIN = currentRow.CDPRODFIN.substring(0, 20);
            return restEngine.post('est_relatorios#/emissao_ajuste', {
                "requestType": "Row",
                "row": currentRow
            }).then(function(callback) {
                var datasetEmissao = callback.dataset.EmissaoAjuste;
                if (datasetEmissao.Details.length) {
                    localStorageEngine.setDataSource('est_relatorios#/emissao_ajuste_details', datasetEmissao.Details).then(() => {
                        localStorageEngine.setDataSource('est_relatorios#/emissao_ajuste_totalizator', datasetEmissao.Totalizator).then(() => {
                            ScreenService.openWindow('est_relatorios#est46001_grid_relatorio_ajuste');
                        });
                    });
                }
                else {
                    MessageService.showMessageByCode('EMPTY_DATA');
                }

            });
        }
    };

    this.validateBirthReport = function(widget, format) {
        var currentRow = widget.currentRow;
        currentRow.__FORMAT = format;
        if (!currentRow.CDPRODFIN)
            currentRow.CDPRODFIN = currentRow.CDARVPRODFIN;

        var compproduto = (currentRow.CDPRODFIN) ? currentRow.CDARVPRODFIN.replace(/[\.\-]/g, '') : null;

        if (widget.isValid()) {
            if (General.comparaPratoProduto(currentRow.CDARVPRODINI, compproduto, getLocalVar('GER_CDPICTPROD'))) {
                if (currentRow.REPORT_NAME == 'GRID') {
                    this.validaRelatorioGrid(currentRow, widget);
                }
                else {
                    this.gerarRelatorio(currentRow);
                }
            }
            else {
                MessageService.showMessageByCode('PRODUTO_INICIAL_MAIOR_FINAL');
            }
        }
    };
    
    this.gerarRelatorio = function(row) {
        row.CDARVPRODFIN = row.CDARVPRODFIN + "zzzzzzzzzzzzzzzzzzzz";
        row.CDARVPRODFIN = row.CDARVPRODFIN.substring(0, 20);
        row.CDPRODINI = row.CDARVPRODINI;
        row.CDPRODFIN = row.CDARVPRODFIN;
        row.CDPRODFINAL = row.CDARVPRODFIN;
        row.__report_name = row.REPORT_NAME;
        if(row.REPORT_NAME === 'EST46000' || row.REPORT_NAME === 'EST46000_retirada') {
            row.IDLANCTO  = row.IDLANCTO || 3;
            row.CUSTOS    = row.CUSTOS || 1;
            row.ORDENANOME = row.ORDENA || 0;
        }
        General.openReport("est_relatorios#/relatorioEmissaoAjuste", row.REPORT_NAME, row);
    };

    this.onEnterRelatorio = function() {
        var container = templateManager.container;
        var stripe = container.getWidget('stripe');
        localStorageEngine.getDataSource('/StripeEmissao').then(function(row) {
            stripe.currentRow.DSFILIAL = row[0].DSFILIAL;
            stripe.currentRow.DSPERIODO = row[0].DSPERIODO;
            stripe.currentRow.DSPRODUTO = row[0].DSPRODUTO;
            if (row[0].CUSTOS == '1') {
                stripe.currentRow.CUSTOS = 'Líquido';
            }
            else {
                stripe.currentRow.CUSTOS = 'Bruto';
            }
        });
    };

    var applyMask = function(fieldValue, maxlength) {
        var mask = {
            "type": "zerofill",
            "params": {
                "right": true,
                "maxlength": maxlength
            }
        };
        return Util.applyMask(fieldValue, mask, maskEngine, ZhUtil);
    };

    this.changeHideInconLabelVisible = function(data, label, hide, name, visibility) {
        data.forEach(element => {
            if (element.name === name) {
                element.label = label;
                element.hideIcon = hide;
                element.isVisible = visibility;
            }
        });
    };

    this.fieldOnChangeRelatorio = function(widget) {

        const ReportName = widget.currentRow.REPORT_NAME;
        const buttonGeneratePdf = widget.getAction('TK_VIEW_BIRTH');

        switch (ReportName) {
            case 'GRID':
                buttonGeneratePdf.label = 'Gerar GRID';
                buttonGeneratePdf.icon = 'file-search';
                break;
            case 'EST46000_retirada':
            case 'EST46000':
                buttonGeneratePdf.label = 'Gerar Pdf';
                buttonGeneratePdf.icon = 'pdf';
                break;
        }
        templateManager.updateTemplate();
    };
    // this.fieldOnChangeRelatorio = function(widget) {

    //     const ReportName = widget.currentRow.REPORT_NAME;
    //     const TotalizaField = widget.getField('NPTOTALIZA');

    //     switch (ReportName) {
    //         case 'GRID':
    //             TotalizaField.readOnly = true;
    //             widget.currentRow.NPTOTALIZA = 1;
    //             TotalizaField.validations = { "required": false };
    //             break;
    //         case 'EST46000_retirada':
    //         case 'EST46000':
    //             TotalizaField.readOnly = false;
    //             TotalizaField.validations = { "required": true };
    //             break;
    //     }
    //     TotalizaField.reload();
    // };

    this.checkUnidadeFields = function(widget) {
        var currentRow = widget.currentRow;

        ProductField.updateProductFilters(widget);
        if (currentRow.REPORT_NAME === 'EST46000' ||
            currentRow.REPORT_NAME === 'GRID' ||
            currentRow.REPORT_NAME === 'EST46000_retirada') {
            if (currentRow.CDFILIAL) {
                Est31300_MovimentacaodeEstoque_Service.requestValidations(currentRow.CDFILIAL).then(function(checks) {
                    currentRow.ALMOXARIFADO = checks.IDUTILALMOX;
                    currentRow.LOCALESTOQUE = checks.IDUTILLCESTQ;
                    currentRow.LOTE = checks.IDUTILLOTE;

                    var almoxarifado = widget.getField('DSALMOXARIFE');
                    var localestoque = widget.getField('DSLOCALESTOQ');
                    var lote = widget.getField('NRLOTEESTQ');

                    if (currentRow.LOTE) {
                        lote.dataSourceFilter[1] = { "name": "CDFILIAL", "operator": "=", "value": currentRow.CDFILIAL };
                        lote.readOnly = false;
                        currentRow.NRLOTEESTOQ = null;
                        this.reloadFields(widget, false, false, true);
                    }
                    else {
                        lote.readOnly = true;
                        lote.setValue(' ');
                        currentRow.NRLOTEESTOQ = " ";
                    }
                    if (currentRow.ALMOXARIFADO) {
                        almoxarifado.dataSourceFilter[0] = { "name": "CDFILIAL", "operator": "=", "value": currentRow.CDFILIAL };
                        almoxarifado.readOnly = false;
                        almoxarifado.validations = { "required": true };
                        this.reloadFields(widget, true, false, false);

                        if (currentRow.LOCALESTOQUE) {
                            localestoque.dataSourceFilter[0] = { "name": "CDFILIAL", "operator": "=", "value": currentRow.CDFILIAL };
                            localestoque.validations = { "required": true };

                            this.checkAlmoxariFields(widget, true);
                        }
                        else {
                            localestoque.readOnly = true;
                            localestoque.validations = null;
                            localestoque.setValue(' ');
                            currentRow.CDLOCALESTOQ = ' ';
                        }
                    }
                    else {
                        almoxarifado.readOnly = true;
                        almoxarifado.validations = null;
                        almoxarifado.setValue(' ');
                        currentRow.CDALMOXARIFE = ' ';
                        localestoque.readOnly = true;
                        localestoque.validations = null;
                        localestoque.setValue(' ');
                        currentRow.CDLOCALESTOQ = ' ';
                    }

                }.bind(this));
            }
            else {
                currentRow.ALMOXARIFADO = false;
                currentRow.LOCALESTOQUE = false;
                currentRow.NRLOTEESTOQ = false;

                widget.getField('DSALMOXARIFE').readOnly = true;
                widget.getField('DSLOCALESTOQ').readOnly = true;
                widget.getField('NRLOTEESTQ').readOnly = true;

                widget.getField('DSALMOXARIFE').validations = null;
                widget.getField('DSLOCALESTOQ').validations = null;
                widget.getField('NRLOTEESTQ').validations = null;

                this.reloadFields(widget, true, true, true);
            }
        }
    };

    this.reloadFields = function(widget, almoxarifado, localestoque, lote) {
        var currentRow = widget.currentRow;

        if (almoxarifado) {
            currentRow.CDALMOXARIFE = (currentRow.ALMOXARIFADO) ? null : ' ';
            currentRow.DSALMOXARIFE = (currentRow.ALMOXARIFADO) ? null : ' ';

            widget.getField('DSALMOXARIFE').reload();
        }

        if (localestoque) {
            currentRow.CDLOCALESTOQ = (currentRow.LOCALESTOQUE) ? null : ' ';
            currentRow.DSLOCALESTOQ = (currentRow.LOCALESTOQUE) ? null : ' ';

            widget.getField('DSLOCALESTOQ').reload();
        }

        if (lote) {
            currentRow.NRLOTEESTQ = null;
            currentRow.NRSUBLOTE = null;

            widget.getField('NRLOTEESTQ').reload();
        }
    };

    this.checkAlmoxariFields = function(widget) {
        var currentRow = widget.currentRow;

        if (currentRow.CDALMOXARIFE && currentRow.LOCALESTOQUE) {
            widget.getField('DSLOCALESTOQ').readOnly = false;
            widget.getField('DSLOCALESTOQ').dataSourceFilter[2] = { "name": "CDALMOXARIFE", "operator": "=", "value": currentRow.CDALMOXARIFE };
        }
        else widget.getField('DSLOCALESTOQ').readOnly = true;

        if (arguments[1]) this.reloadFields(widget, true, true, true);
        else this.reloadFields(widget, false, true, false);
    };

    this.intervaloChange = function(field) {
        let widget = field.widget;
        widget.currentRow.DTPERINI = widget.currentRow.INTERVALO.start;
        widget.currentRow.DTPERFIN = widget.currentRow.INTERVALO.end;
    };

    /*  This function will change reports titles according to each widget name  */
    this.onFormatReport = function(args, afterOpenReport = false) {
        const { owner: widget } = args;
        const metadata = args.e.metadata;
        const detailTitle = "Ajuste de Inventário - Analítico";
        const totalizatorTitle = "Ajuste de Inventário - Analítico (Totalizador)";

        if (afterOpenReport)
            ZhLayoutPreferences.applyOriginalLayout(widget);
        else {
            metadata.title = widget.name == 'detailsWidget' ? detailTitle : totalizatorTitle;
            ZhLayoutPreferences.applyOriginalLayout(widget);
        }
    };

    /*  This function will hide or show the totalization div according to widegt name*/
    this.onFormatGrid = function(widget) {
        const interval = setInterval(() => {
            if (widget.name == 'totalizatorWidget') {
                $("div.tr.cell1.group-footer").css("display", "none");
            }
            else {
                $("div.tr.cell1.group-footer").css("display", "");
            }
            clearInterval(interval);
        }, 1300);
    };

    /*  This function will set the previous window as default always that the 
     *  grid window gets opened */
    this.windowChangeHandler = function() {
        templateManager.historyItems = [
            "est_relatorios#est46000_emissao_ajuste_inventario",
            "est_relatorios#est46001_grid_relatorio_ajuste"
        ];
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Est46000_EmissaoAjusteInventario_Controller', est46000_EmissaoAjusteInventario_Controller);
});
