package com.javaseleniumtemplate.dbsteps;

import com.javaseleniumtemplate.utils.DBUtils;
import com.javaseleniumtemplate.utils.Utils;

public class DBSteps {
    private static String queriesPath = "src/test/java/com/javaseleniumtemplate/queries/";


    public static String retornaSenhaDoUsuarioDB(String usuario) {
        String query = Utils.getFileContent(queriesPath + "retornaSenhaDoUsuario.sql")
                .replace("$usuario", usuario);

        return DBUtils.getQueryResult(query).get(0);
    }

    public static String retornaQuatidadeEstoque(String numeroLancamento) {
        String query = Utils.getFileContent(queriesPath + "retornaQuantidadeEstoque.sql")
                .replace("$ntlancestq", numeroLancamento);
        return DBUtils.getQueryResult(query).get(0);
    }

    public static String retornaQuantidadeSolicitadaEstoque(String quantidadeSolicitada) {
        String query = Utils.getFileContent(queriesPath + "retornaQuantidadeSolicitadaEstoque.sql")
                .replace("retornaValorSolicitado", quantidadeSolicitada);
        return DBUtils.getQueryResult(query).get(0);
    }

    public static String retornaValorTotalQuantidadeEstoque(String valorLancamentoTotalEstoque) {
        String query = Utils.getFileContent(queriesPath + "retornaValorTotalQuantidadeEstoque.sql")
                .replace("$ntlancestq", valorLancamentoTotalEstoque);
        return DBUtils.getQueryResult(query).get(0);
    }

    public static String retornaQuantidadeDevolvidaEstoque(String quantidadeDevolvidaEstoque) {
        String query = Utils.getFileContent(queriesPath + "retornaQuantidadeDevolvidaEstoque.sql")
                .replace("$devolucaoEstoque", quantidadeDevolvidaEstoque);
        return DBUtils.getQueryResult(query).get(0);
    }

    public static String retornaQuantidadeRestanteEstoque(String quantidadeRestanteEstoque) {
        String query = Utils.getFileContent(queriesPath + "retornaQuantidadeRestanteEstoque.sql")
                .replace("valorRestante", quantidadeRestanteEstoque);
        return DBUtils.getQueryResult(query).get(0);

    }

    public static String retornaQuantidadeRequisitadaEstoque(String requisitada) {
        String query = Utils.getFileContent(queriesPath + "retornaQuantidadeRequisitadaEstoque.sql")
                .replace("quantidadeRequisitada", requisitada);
        return DBUtils.getQueryResult(query).get(0);
    }

    public static String retornaValorUnitarioLancadoEstoque(String quantidadeSolicitada) {
        String query = Utils.getFileContent(queriesPath + "retornaValorUnitarioEstoque.sql")
                .replace("valorLancado", quantidadeSolicitada);
        return DBUtils.getQueryResult(query).get(0);
    }
}


