package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class RecalculoDeEstoquePage extends PageBase {

    /// Loading Page
    By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
    By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");
    By lupa = By.xpath("//span[@zh-icon='search no-border icon-white']");//Nessa tela precisei colocar um clique antes e cada float-control


    //Recalculo de Estoque

    //Unidade
    By btnLimparUnidade = By.xpath("//*[@data-zh-id='19884086213681016602745']//*[@zh-icon='no-border close-x']");
    By btnIconProcurarUnidade = By.xpath("//div[@data-zh-id='19884086213681016602745']//*[@class='zh-icon zh-icon-search zh-icon-no-border'] ");
    By unidadeSelecionada = By.xpath("//span[text()='HELA INGREDIENTES BRASIL']");


    //Almoxarifado
    By btnIconAlmoxarifado = By.xpath("//div[@id='DSALMOXARIFE']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By almoxarifado = By.xpath("//span[text()='HELA MATRIZ']");

    //Produto Inicial
    By btnProdutoInicial = By.xpath("//div[@id='NMPRODINI']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By produtoInicial = By.xpath("//span[text()='Hela Poultry Broth Paste Clear']");

    //Produto Final
    By btnPrdutoFinal = By.xpath("//div[@id='NMPRODFIN']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By produtoFinal = By.xpath("//span[text()='Hela Crema Di Balsamico Lemon 380Ml']");

    //Data
    By iconeData = By.xpath("//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
    By data = By.xpath("//div[@class='day today']");


    //Recalcular
    By recalcular = By.xpath("//span[text()='Recalcular']");
    By actionOK = By.xpath("//span[text()='OK']");


    public void limparUnidade() {
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnLimparUnidade);
        click(btnLimparUnidade);
    }

    public void selecionarUnidade() {
        //unidade

        waitForVisibilityOfElementLocated(btnIconProcurarUnidade);
        click(btnIconProcurarUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);

    }

    public void clicarLupa() {
        waitForVisibilityOfElementLocated(lupa);
        click(lupa);//Nessa tela precisei colocar um clique para abrir a lupa
    }

    public void procurarUnidade(String campoUnidade) {
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, campoUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarUnidade(){
        waitForVisibilityOfElementLocated(unidadeSelecionada);
        click(unidadeSelecionada);
        waitForInvisibilityOfElementLocated(loadingWait);
    };

    public void selecionarAlmoxarifado() {

        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado);
        click(btnIconAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void buscarAlmoxarifado(String campoAlmoxarifado) {
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, campoAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    ;

    public void clicarAlmoxarifado() {
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    ;

    public void buscarProdutoInicial(String campoProdutoInicial) {
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, campoProdutoInicial);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void campoProdutoInicial() {
        //Produto inicial
        waitForVisibilityOfElementLocated(btnProdutoInicial);
        click(btnProdutoInicial);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void selecionarProdutoInicial() {
        waitForVisibilityOfElementLocated(produtoInicial);
        click(produtoInicial);
        waitForInvisibilityOfElementLocated(loadingWait);

    }

    public void campoProdutoFinal() {
        waitForVisibilityOfElementLocated(btnPrdutoFinal);
        click(btnPrdutoFinal);
        waitForInvisibilityOfElementLocated(loadingWait);
    }



    //Produto Final
    public void buscarProdutoFinal(String campoProdutoFinal) {
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        // click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, campoProdutoFinal);
        waitForInvisibilityOfElementLocated(loadingWait);
    };

    public void selecionarProdutoFinal() {
        waitForVisibilityOfElementLocated(produtoFinal);
        click(produtoFinal);
        waitForInvisibilityOfElementLocated(loadingWait);
    };




    public void selecionarData() {
        //data
        waitForVisibilityOfElementLocated(iconeData);
        click(iconeData);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(data);
        click(data);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void recalcularEstoque() {
        waitForVisibilityOfElementLocated(recalcular);
        click(recalcular);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void clicarEmConfirmar() {
        waitForVisibilityOfElementLocated(actionOK);
        click(actionOK);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
}




