package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;

import org.openqa.selenium.By;

public class RequisicaoDeEstoquePage extends PageBase {


    ///Mapoping
    //Evento de loading da pagina:
    By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
    By actionOK = By.xpath("//span[text()='OK']");

    By salvar = By.xpath("//span[text()='Salvar']");
    //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:

    By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");
    //Aplicar Filtro
    By clear = By.xpath("//*[@data-zh-id='15329051871499023554582_filter_action_clear']");
    By iconeUnidade = By.xpath("//*[@data-zh-id='15329051873416472306624']//*[@id='NMFILIAL']");
    By unidade = By.xpath(" //span[contains(text(),'HELA INGREDIENTES BRASIL') and @data-item-index='0']");

    By iconeData = By.xpath("//*[@data-zh-id='15329051873432479889612']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
    By dataEscolhida = By.xpath("//*[@id='zh-calendar-Calendar']//*[.='1']");
    By iconeDataEscolhidaPrevista = By.xpath("//*[@data-zh-id='15329051873711188136614']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");

    By btnOkFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");
    By btnAplicarFilro = By.xpath("//span[text()='Aplicar filtro']");


    // EfetuarRequisicaodeEstoque
    By btnAdicionar = By.xpath("//*[@data-zh-id='15329051873329380480662']");
    By descricao = By.id("DSREQUESTO");

    By setor = By.xpath("//*[@data-zh-id='1532905187866992293659']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By setorEscolhido = By.xpath("//span[text()='Administrativo']");

    //Almoxarifado
    By almoxarifadoOrigem = By.xpath("//*[@data-zh-id='15329051872400909778906']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By almoxarifadoDestino = By.xpath("//*[@data-zh-id='15329051872975276529638']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By selectAlmoxarifadoOrigem = By.xpath("//span[text()='HELA MATRIZ']");

    By selectAlmoxarifadoDestino = By.xpath("//span[text()='HELA LOJA']");




    //Produto

    By btnOk = By.xpath("//span[text()='OK']");

    By clicarLupa = By.xpath("//*[@id='NMFILIAL']//*[@id='path15756']");

    By btnAdicionarProduto = By.xpath("//*[@data-zh-id='15329051874071057401608']");

    By produto = By.xpath("//*[@data-zh-id='1532905187356114781593']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By selectProduto = By.xpath("//span[text()='SUMO DE LIMAO - CX12 500ML']");
    By quantidadeRequisitada = By.id("QTREQUESTO");


    //Banco
    By numeroLancado = By.cssSelector(".row-editing > .td:nth-child(1) > span");



    //Editar

    By selecionarRequisicao = By.xpath("//span[text()='Teste Automatizado']");
    By editar = By.xpath("//*[@data-zh-id='15329051873600810543665']");

    // Excluir
    By itemDeletado = By.xpath("//span[text()='Teste Automatizado']");
    By excluir = By.xpath("//*[@data-zh-id='15329051871129519578667']");
    By btnAlerta = By.xpath("//span[text()='Sim']");


    By teste = By.xpath("//span[text()='0001 | HELA INGREDIENTES BRASIL']");

    public void limparFiltro() {
        click(clear);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void realizarcliqueLupa(){
        waitForVisibilityOfElementLocated(clicarLupa);
        click(clicarLupa);
        waitForVisibilityOfElementLocated(loadingWait);
    }
    public void acaoBuscar() {
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
    }
    public void campoUnidade() {

        waitForVisibilityOfElementLocated(iconeUnidade);
        click(iconeUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buscarUnidade(String descUnidade) {
        sendKeys(campoProcurarFloatControl, descUnidade);
        sendKeys(unidade,descUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoData() {
        waitForVisibilityOfElementLocated(iconeData);
        click(iconeData);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void dataEscolhida() {
        waitForVisibilityOfElementLocated(dataEscolhida);
        click(dataEscolhida);
    }
    public void confirmarFiltro() {
        waitForVisibilityOfElementLocated(btnOkFiltro);
        click(btnOkFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoDataPrevista() {
        waitForVisibilityOfElementLocated(iconeDataEscolhidaPrevista);
        click(iconeDataEscolhidaPrevista);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void preencherDataPrevista() {

        waitForVisibilityOfElementLocated(dataEscolhida);
        click(dataEscolhida);

    }
    public void acaoConfirmar() {
        waitForVisibilityOfElementLocated(actionOK);
        click(actionOK);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buttonAplicarFiltro() {
        click(btnAplicarFilro);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clickAdicionar() {
        click(btnAdicionar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoDescricao(String campoDescricao) {
        waitForVisibilityOfElementLocated(descricao);
        sendKeys(descricao, campoDescricao);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoSetor() {
        waitForVisibilityOfElementLocated(setor);
        click(setor);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void preencherCampoSetor(String campoSetor) {
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, campoSetor);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarSetor() {
        click(setorEscolhido);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoAmoxarifadoOrigem() {
        waitForVisibilityOfElementLocated(almoxarifadoOrigem);
        click(almoxarifadoOrigem);
    }
    public void selecionarAlmoxarifadoOrigem(String campoAlmoxarifadoOrigem) {
        sendKeys(campoProcurarFloatControl, campoAlmoxarifadoOrigem);
        click(selectAlmoxarifadoOrigem);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoAlmoxarifadoDestino() {
        waitForVisibilityOfElementLocated(almoxarifadoDestino);
        click(almoxarifadoDestino);
    }
    public void selecionarCampoAlmoxarifadoDestino(String campoAlmoxarifadoDestino) {
        sendKeys(campoProcurarFloatControl, campoAlmoxarifadoDestino);
        click(selectAlmoxarifadoDestino);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buttonSalvar() {
        waitForVisibilityOfElementLocated(salvar);
        click(salvar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buttonAdicionarProduto() {
        waitForVisibilityOfElementLocated(btnAdicionarProduto);
        click(btnAdicionarProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarProduto() {
        waitForVisibilityOfElementLocated(produto);
        click(produto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buscarProduto(String campoProduto) {
        sendKeys(campoProcurarFloatControl, campoProduto);
        click(selectProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void campoQuantidadeRequisitada(String campoQuantidadeRequisitada) {
        waitForVisibilityOfElementLocated(quantidadeRequisitada);
        sendKeys(quantidadeRequisitada, campoQuantidadeRequisitada);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void bancoCaptura() {
        waitForVisibilityOfElementLocated(numeroLancado);
        click(numeroLancado);
    }
    public String retornaQuantidadeRequisitadaItem(){
    return getText(numeroLancado);


    }

    public void selecionarRequisicaoEditar(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(selecionarRequisicao);
        click(selecionarRequisicao);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buttonEditar(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(editar);
        click(editar);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void campoDescricaoEditado(String campoEditado){
        waitForVisibilityOfElementLocated(descricao);
        clearAndSendKeys(descricao,campoEditado);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void selecionarItemDeletado(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(itemDeletado);
        click(itemDeletado);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buttonExcluir(){
        waitForVisibilityOfElementLocated(excluir);
        click(excluir);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void clicarAlert(){
        waitForVisibilityOfElementLocated(btnAlerta);
        click(btnAlerta);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
}
